var oParamDlg, oReportDlg, oHelpDlg, oLoginDlg;
var tcount=1; // ThermometerCount
var dmatidx=1; // 1,2,3...
var textonbut=true; // TextOnButtons
var popupsts=false; // Popup States
var forThermo=0; // 0,1,2...
var tIDs=new Array();
var authenticated=false;
var login='';
var password='';

function Thermo()
{
   this.ID='';
   this.State=0; // keep 0,1,2,3,4
   this.Name='';
   this.LowLimit=0;
   this.LowWindow=0;
   this.HighLimit=0;
   this.HighWindow=0;
   this.WindowMinutes=0;
   this.RecordingSeconds=10
   this.SoundAlarm=false;
   this.SMSAlarm=false;
   this.PortAlarm=false;
   this.RelayID=1;
   
   if (arguments.length>=1) {
      this.Name=arguments[0];
   }
   
   if (arguments.length>=2) {
      var x=parseInt(arguments[1]);
      if (isNaN(x)) { x=0; }
      this.LowLimit=x;
      this.LowWindow=x-2;
   }
   
   if (arguments.length>=3) {
      var x=parseInt(arguments[2]);
      if (isNaN(x)) { x=0; }
      this.HighLimit=x;
      this.HighWindow=x+2;
   }
}

var thermo=[ new Thermo('Ψύκτης #1', -4, 10) ]; 
for (var i=1;i<20;i++) {
   thermo.push( new Thermo() );
}

var days=['Κυ', 'Δε', 'Τρ', 'Τε', 'Πε', 'Πα', 'Σα'];   

var buttons=[
   {img:'adjust.png', text:'Παράμετροι'},
   {img:'report.png', text:'Ελεγχοι'},
   {img:'help.png', text:'Βοήθεια'}
];

var states=[ 'Εκτός λειτουργίας', 'Σε λειτουργία', 'Ανεφοδιασμός', 'Απόψυξη', 'Alarm' ];

Array.prototype.inArray = function (value)
{
   for (var i=0; i < this.length; i++) {
      if (this[i] == value)
         return true;
   }
   // not found so far
   return false;
}
function redrawButtons()
{
   for (var i=1;i<=3;i++) {
      var ids='#b'+i;
      var html='<img id=bimg'+i+' src="' ;
      html += ((i==3 && authenticated)?'help_grn.png':buttons[i-1].img);
      html += '">';
      if (textonbut) {
         html += ' <br>'+buttons[i-1].text;
      }
      $(ids).html(html);
   }
}   
function fill2Zero(x)
{
   var rets = ''+x;
   while (rets.length<2) {
      rets = '0'+rets; 
   }
   return rets;
}
function toInt(v)
{
   var x=parseInt(v);
   if (isNaN(x)) { x=0; }
   return x;
}
function checkLogin()
{
   if ($('#login').val()!=login ) {
      window.alert('Λάθος όνομα σύνδεσης!');
      return false;
   }
            
   if ($('#pwd').val()!=password ) {
      window.alert('Λάθος κωδικός σύνδεσης!');
      return false;
   }
   
   return true;
}
function onTimer()
{ // clock + emulation   
   var d1=new Date();
   $('#timex').text( days[d1.getDay()] + ' ' + d1.getDate() + '/' + (d1.getMonth()+1) + '/' + d1.getFullYear() + ' ' + 
      fill2Zero(d1.getHours()) + ':' + fill2Zero(d1.getMinutes()) + ':' + fill2Zero(d1.getSeconds()) );
      
   for (var i=1;i<=tcount;i++) {
      var x=Math.floor( Math.random()*35 )-10;
      $('#cc'+i).text(x);
      $('#ccL'+i).css('color', (x>=thermo[i-1].LowLimit && x<=thermo[i-1].HighLimit) ? '#008000' : '#ff0000' );
   }
}

//window.setInterval(onTimer,1000);

$(function(){
   $.datepicker.setDefaults({dateFormat: 'dd-mm-yy'});
   
   //writeParamLines();
   redrawButtons();
   showThermometers();
   refreshScreen();
   
   oParamDlg = $('#paramDlg').dialog({autoOpen:false, resizable:false, modal:true, width:680, buttons: {
		   'OK': function() {
            textonbut = $('#textonbut').get(0).checked;
            redrawButtons();
            
            popupsts = $('#popupsts').get(0).checked; 
            
            tcount = $('#thermoc').val();
            showThermometers();
            
            for (var i=1;i<=tcount;i++) {
               // Fill thermo array
               var the = thermo[i-1]; //new Thermo();
               
               the.ID = $('#pid'+i).val(); 
               if (the.ID==null) { 
                  the.ID=''; 
               }
               the.Name = $('#pname'+i).val();
               the.LowLimit = toInt( $('#plimitdn'+i).val() );
               the.LowWindow = toInt( $('#pwindn'+i).val() );
               the.HighLimit = toInt( $('#plimitup'+i).val() );
               the.HighWindow = toInt( $('#pwinup'+i).val() );
               the.WindowMinutes = toInt( $('#winmint'+i).val() );
               the.RecordingSeconds = toInt( $('#recsec'+i).val() );
               the.SoundAlarm = $('#soundalm'+i).get(0).checked;
               the.SMSAlarm = $('#smsalm'+i).get(0).checked;
               the.PortAlarm = $('#relayalm'+i).get(0).checked;
               the.RelayID = toInt( $('#relayid'+i).val() );
               
               if (the.LowWindow>the.LowLimit) {
                  window.alert('Θερμόμετρο '+i+': το Κάτω Παράθυρο δεν μπορεί να είναι πάνω από το Κάτω Οριο!');
                  continue;
               }
               
               if (the.HighWindow<the.HightLimit) {
                  window.alert('Θερμόμετρο '+i+': το Ανω Παράθυρο δεν μπορεί να είναι κάτω από το Ανω Οριο!');
                  continue;
               }
               
               thermo[i-1] = the;               
            }
            
            // Show on screen
            refreshScreen();
            
            sendXMLtoMaster();
            			   
            $( this ).dialog( "close" );
		   },
		   'Ακυρο': function() {
			   $( this ).dialog( "close" );
		   },
		   'Επικοινωνίες': function() {
		      $( this ).dialog( "close" );
		      if (external.Frigo!=undefined) {
		         external.CommParameters();
		      }
		      else {
		         window.alert('Need external program!');
            }
		   }
		}
   });
   
   $('.date').attr('readonly','readonly').width(100);
   var today=new Date();
   $( "#dateFrom, #dateTo" ).datepicker().datepicker('setDate',today);
   
   var shtml='';
   for (var i=0;i<24;i++) {
      for (var j=0;j<60;j+=15) {
         var ts = (100+i).toString().substr(1)+':'+(100+j).toString().substr(1);
         shtml += '<option value="'+ts+'">'+ts+'</option>';
      }
      shtml += '<option value="23:59">23:59</option>';
   }
   $('#timeFrom, #timeTo').html(shtml);
   $('#timeTo option[value="23:59"]').attr('selected', 'selected');
   
   oReportDlg = $('#reportDlg').dialog({autoOpen:false, resizable:false, modal:true, width:600, buttons: {
         'OK': function() {
            if ($('#outscreen').attr('checked')==undefined && $('#outprinter').attr('checked')==undefined) {
               window.alert('Πρέπει να καθορίσετε έξοδο!');
               return;
            }

            var x1=$('#thermoFrom').val();
            var x2=$('#thermoTo').val();            
            var dt1=$('#dateFrom').val().split('-').reverse().join('') + $('#timeFrom').val().replace(':','') + '00';
            var dt2=$('#dateTo').val().split('-').reverse().join('') + $('#timeTo').val().replace(':','') + '00';
            var x3=$('input[name="OUT"]:checked').val();
            
            if (external.Frigo!=undefined) {
               external.Report( x1, x2, dt1, dt2, x3 );
            }
            else {
               alert( [ x1, x2, dt1, dt2, x3 ] ); 
            }
            
            $( this ).dialog( "close" );
         },
         'Ακυρο': function() {
            $( this ).dialog( "close" );
         }
      }
   });
   
   oLoginDlg = $('#loginDlg').dialog({autoOpen:false, resizable:false, modal:true, width:400, buttons: {
         'Σύνδεση': function() {
            if (!checkLogin()) 
               return;
            
            authenticated=true;
            $('#bimg3').attr('src','help_grn.png');

            $( this ).dialog( "close" );
         },
         'Αλλαγή': function() {
            if (!checkLogin()) 
               return;
            
            login=$('#newlogin').val();
            password=$('#newpwd').val();
            authenticated=true;
            $('#bimg3').attr('src','help_grn.png');
            sendXMLtoMaster() ;
            
            $( this ).dialog( "close" );
         },
         'Ακυρο': function() {
            $( this ).dialog( "close" );
         }
      } 
   });
   
   $('#tabs-env').html( "<table><tr><td>App Name:</td><td>" + navigator.appName + "</td></tr>" +
      "<tr></td><td>App CodeName:</td><td>" + navigator.appCodeName + "</td></tr>"+
      "<tr><td>User Agent:</td><td>" + navigator.userAgent + "</td></tr>" + 
      "<tr><td>App Version:</td><td>" + navigator.appVersion+"</td></tr></table>" );
   $('#helpInsi').tabs();
   oHelpDlg = $('#helpDlg').dialog({autoOpen:false, resizable:false, modal:true, width:600, buttons:{
      'OK': function() {
         $( this ).dialog( "close" );
      },
      'Αποσύνδεση': function() {
         authenticated=false;
         $('#bimg3').attr('src','help.png');
         $( this ).dialog( "close" );
      },
      'Πληκτρολόγιο': function() {
         if (external.Frigo!=undefined) {
            external.CallOSK();
         }
         $( this ).dialog( "close" );
      }
   } });
   
   $('#stateDlg').dialog( {autoOpen:false, resizable:false, modal:true, width:560} );
   for (var i=0;i<4;i++) {
      $('#state'+i).text(states[i]);
   }

   if (external.Frigo==undefined) {      
      $.get('tprm.xml', function(data){
         Initialize(data);
      }, 'text');
   }
   
} );
function moveCount(x)
{
   var osel = $('#thermoc').get(0);
   var si = osel.selectedIndex + x;
   if (si<0) {
      si=0;
   }
   else if (si>(osel.options.length-1)) {
      si=osel.options.length-1;
   }
   osel.selectedIndex=si; 
   onThermoChange();     
}
function sendXMLtoMaster()
{
   var xml=new XMLWriter();
            
   xml.Node('ThermometerCount', tcount);
   xml.Node('TextOnButtons', textonbut);
   xml.Node('PopupStage', popupsts);
   xml.Node('Login', login);         
   xml.Node('Password', password);
            
   xml.BeginNode('ThermometerArray');
            
   for (var i=1;i<=20;i++) {
      var the = thermo[i-1];
      // Fill XML
      xml.BeginNode('Thermometer');
      xml.Node('State', the.State );
      xml.Node('ID', the.ID );
      xml.Node('Name', the.Name );
      xml.Node('LowLimit', the.LowLimit );
      xml.Node('LowWindow', the.LowWindow );
      xml.Node('HighLimit', the.HighLimit );
      xml.Node('HighWindow', the.HighWindow );
      xml.Node('WindowMinutes', the.WindowMinutes );
      xml.Node('RecordingSeconds', the.RecordingSeconds );
      xml.Node('SoundAlarm', the.SoundAlarm );
      xml.Node('SMSAlarm', the.SMSAlarm );
      xml.Node('PortAlarm', the.PortAlarm );
      xml.Node('RelayID', the.RelayID );
      xml.EndNode();
   }
            
   xml.EndNode();
            
   if (external.Frigo!=undefined) {
      external.SaveThermometerParams(xml);
   }
   else { // debug
      $.post( 'save.php', { 'XML': xml.toString() }, function(data) {
         if (data!='OK') { 
            alert(data); 
         }
      } );
   }
}
function refreshScreen()
{                     
   for (var i=1; i<=tcount; i++) {
      $('#cname'+i).text( i+'# '+thermo[i-1].Name );
               
      $('#climitdn'+i).text( thermo[i-1].LowLimit );
      $('#cwindn'+i).text( thermo[i-1].LowWindow );
               
      $('#climitup'+i).text( thermo[i-1].HighLimit );
      $('#cwinup'+i).text( thermo[i-1].HighWindow );
   } 
}
function Initialize(data)
{
   try {                           
      var xmlo = $.parseXML(data);
      
      login = $(xmlo).find('Login').text(); 
      password = $(xmlo).find('Password').text(); 
         
      tcount = parseInt( $(xmlo).find('ThermometerCount').text() );
      if (isNaN(tcount) || tcount<1) { tcount=1; }
         
      textonbut = ( $(xmlo).find('TextOnButtons').text()=='true' );
      popupsts = ( $(xmlo).find('PopupStage').text()=='true' );
         
      $('#thermoc').get(0).selectedIndex = tcount-1; 

      var i=0;         
      $(xmlo).find('Thermometer').each( function(){
            var the=new Thermo();
            
            var sts = toInt( $(this).find('State').text() );
            the.State = sts<4?sts:0;
              
            the.ID = $(this).find('ID').text();
            the.Name = $(this).find('Name').text();
            the.LowLimit = toInt( $(this).find('LowLimit').text() );
            the.LowWindow = toInt( $(this).find('LowWindow').text() );
            the.HighLimit = toInt( $(this).find('HighLimit').text() );
            the.HighWindow = toInt( $(this).find('HighWindow').text() );
            the.WindowMinutes = toInt( $(this).find('WindowMinutes').text() );
            the.RecordingSeconds = toInt( $(this).find('RecordingSeconds').text() );
            the.SoundAlarm = $(this).find('SoundAlarm').text()==='true';
            the.SMSAlarm = $(this).find('SMSAlarm').text()==='true';
            the.PortAlarm = $(this).find('PortAlarm').text()==='true';
            the.RelayID = toInt( $(this).find('RelayID').text() ); 
            thermo[i++] = the;
         } );
         
      redrawButtons();
      showThermometers();
      refreshScreen();
   }
   catch (e) {
      window.alert('Failed to parse XML: '+e.message);
   }
}
var inTimer=false;
function ThermoAlarm(id)
{
   for (var i=1;i<=20;i++) {
      if (thermo[i-1].ID==id) { // found some value
         thermo[i-1].State=4; // alarm
         drawStatus(i);
         break;
      } 
   } 
}
function ThermoCount(id,x)
{               
   if (!inTimer) {
      inTimer=true;
      doThermoCount(id,x);
      inTimer=false;
   }
}
function doThermoCount(id,x)
{
   var j=0; // ->undef
   for (var i=1;i<=20;i++) {
      if (thermo[i-1].ID==id) { // found some value
         j=i; // 1,2,3,4
         break;
      } 
   }

   if (j==0) { // still not found
      if (!tIDs.inArray(id)) {
         tIDs.push(id);
         window.alert('Παραλήφθηκε μέτρηση για το θερμόμετρο με ID '+id+"\nΠρέπει να κάνετε παραμετροποίηση");
      }
      return;
   }
   
   // Some value found:
   var d1=new Date();
   $('#timex').text( days[d1.getDay()] + ' ' + d1.getDate() + '/' + (d1.getMonth()+1) + '/' + d1.getFullYear() + ' ' + 
      fill2Zero(d1.getHours()) + ':' + fill2Zero(d1.getMinutes()) + ':' + fill2Zero(d1.getSeconds()) );
      
   $('#cc'+j).text(x);
   var color='#008000';
   if (x<thermo[j-1].LowWindow || x>thermo[j-1].HighWindow) {
      color='#ff0000';
   }
   else if (x<thermo[j-1].LowLimit || x>thermo[j-1].HighLimit) {
      color='#FFCC00'; // orange
   }
   $('#ccL'+j).css('color', color );
}
function onThermoChange()
{
   tcount=$('#thermoc').val();
   openParams();
}
function openParams()
{
   if (!authenticated) {
      $('#login').val('');
      $('#pwd').val('');
      $('#newlogin').val('');
      $('#newpwd').val('');
      oLoginDlg.dialog('open');
      return;
   }
   
   writeParamLines();
   
   // Get existing IDs
   var ar1=new Array();
   for (var i=0;i<20;i++) {
      if (thermo[i].ID.length>0 && !ar1.inArray(thermo[i].ID)) {
         ar1.push(thermo[i].ID);
      }
   }
   
   ar1.sort();
   var shtml='<option value=""></option>';
   for (var i=0;i<ar1.length;i++) {
      shtml += '<option value="'+ar1[i]+'">'+ar1[i]+'</option>';
   }
   
   // Get new IDs
   var ar2=new Array();
   for (var i=0;i<tIDs.length;i++) {
      if (!ar1.inArray(tIDs[i])) { // not in 'existing' list
         ar2.push(tIDs[i]);
      }
   }

   if (ar2.length>0) {
      ar2.sort();
      shtml += '<optgroup label="Νέα εγγραφή">';
      for (var i=0;i<ar2.length;i++) {
         shtml += '<option value="'+ar2[i]+'">'+ar2[i]+'</option>';
      }
      shtml += '</optgroup>';
   }   
   
   var n=thermo.length;
   for (var i=1;i<=n;i++) {
      if (i>tcount)
         break;
         
      $('#pid'+i).html( shtml );
      var sel="#pid"+i+" option[value='"+thermo[i-1].ID+"']";
      $(sel).attr('selected', 'selected');
      
      $('#pname'+i).val( thermo[i-1].Name );
      $('#plimitdn'+i).val( thermo[i-1].LowLimit );
      $('#pwindn'+i).val( thermo[i-1].LowWindow );
      $('#plimitup'+i).val( thermo[i-1].HighLimit );
      $('#pwinup'+i).val( thermo[i-1].HighWindow );
      $('#winmint'+i).val( thermo[i-1].WindowMinutes );
      $('#recsec'+i).val( thermo[i-1].RecordingSeconds );
      $('#soundalm'+i).get(0).checked = thermo[i-1].SoundAlarm; 
      $('#smsalm'+i).get(0).checked = thermo[i-1].SMSAlarm; 
      $('#relayalm'+i).get(0).checked = thermo[i-1].PortAlarm; 
      $('#relayid'+i).val( thermo[i-1].RelayID );
   }
   
   $('#textonbut').get(0).checked = textonbut;
   $('#popupsts').get(0).checked = popupsts;
   
   if (external.Frigo!=undefined) {
      external.CallOSK();
   } 
   
   oParamDlg.dialog('open');
}
function openReport()
{        
   if (!authenticated) {
      oLoginDlg.dialog('open');
      return;
   }
   
   var shtml='';
   for (var i=1;i<=20;i++) {
      shtml += '<option value="'+i+'">'+i+'# '+thermo[i-1].Name+'</option>';
   }
   $('#thermoFrom').html( shtml );
   $('#thermoTo').html( shtml );
   
   if (external.Frigo!=undefined) {
      external.CallOSK();
   }
   
   oReportDlg.dialog('open');
}
function openHelp()
{
   oHelpDlg.dialog('open');
}
function make_table(ix, nrows)
// ix: 0,1,2...
{  
   var j=(ix/nrows)+1; // 1,2,3...
   
   var shtml='<table id=mat class=large cellspacing=2 cellpadding=0 width=924>'+
      '<colgroup style="width:260px"></colgroup>'+
      '<colgroup style="width:150px"></colgroup>'+
      '<colgroup style="width:240px"></colgroup>'+
      '<colgroup style="width:150px"></colgroup>';
      
   for (var i=ix+1;i<=ix+nrows;i++) { 
      if (i>tcount)
         break;
         
      shtml += '<tr><td id=cname'+i+' class="infoborder paneltop" colspan=5>'+
         thermo[i-1].Name+
         '</td></tr>'+
         '<tr>'+
         '<td id=tstate'+i+' class="infoborder operate">'+
         '&nbsp;'+
         '</td>'+
         '<td class="infoborder infopanel">'+
            '<table class=limits cellspacing=0 cellpadding=0>'+
            '<tr>'+
            '<td>Κάτω όριο</td>'+
            '<td class=rightTd><span id=climitdn'+i+'></span><sup>o</sup></td>'+
            '</tr>'+
            '<tr>'+
            '<td>Παράθυρο</td>'+
            '<td class=rightTd><span id=cwindn'+i+'></span><sup>o</sup></td>'+
            '</tr>'+
            '</table>'+
         '</td>'+
         '<td id=ccL'+i+' class="infoborder infomain">'+
         '<span id=cc'+i+'></span><sup>o</sup> C'+
         '</td>'+
         '<td class="infoborder infopanel">'+
            '<table class=limits cellspacing=0 cellpadding=0>'+
            '<tr>'+
            '<td>Πάνω όριο</td>'+
            '<td class=rightTd><span id=climitup'+i+'></span><sup>o</sup></td>'+
            '</tr>'+
            '<tr>'+
            '<td>Παράθυρο</td>'+
            '<td class=rightTd><span id=cwinup'+i+'></span><sup>o</sup></td>'+
            '</tr>'+
            '</table>'+
         '</td>'+
         '<td>'+
         '<button style="width:100px;" onclick="newstate('+i+')">'+
         (textonbut?'<img src="refresh36x36.png"><br>Αλλαγή':'<img src="refresh48x48.png">')+'</button>'+
         '</td>'+
         '</tr>';         
   }
   
   shtml += '</table>';
   
   $('#dmat'+j).html(shtml);
}
function showThermometers()
{
   var h=$(window).height(); // 600 or 768
   var nrows = (h<715?4:5);
   var maxh = nrows*115; 
   
   $('#dmat1').show();
   dmatidx=1;
   
   for (var i=0; i<tcount; i += nrows) {
      make_table(i, nrows);
   }
   
   // Once we have structured the DOM, we can paint it
   for (var i=1;i<=tcount;i++) {
      drawStatus(i);
   }
   
   var divheight=(tcount<=nrows?tcount*115:maxh);
   var top=Math.floor( (h-140-divheight)/2 )+130;
   $('#dmat1').css('height', divheight+'px' );
   $('#dmat1').css('top', top+'px' );
   
   for (var i=2;i<=5;i++) {
      $('#dmat'+i).css('top', top+'px' );
      $('#dmat'+i).hide();      
   }
   
   top=Math.floor( (h-140-maxh)/2 )+130;
   
   $('#goback').css('top', top+'px' );
   $('#goback').css('height', maxh+'px' );
   
   $('#gonext').css('top', top+'px' );
   $('#gonext').css('height', maxh+'px' );
   
   moveTab(0);
}
function goBack()
{
   if (dmatidx>1) {
      $('#dmat'+dmatidx).hide();
      dmatidx--;
      $('#dmat'+dmatidx).show();
      if (dmatidx==1) {
         $('#goback').hide();
      }
   }
}
function moveTab(x)
{
   var h=$(window).height(); // 600 or 768
   var nrows = (h<715?4:5);
   var ntab=Math.ceil(tcount/nrows);
   
   $('#dmat'+dmatidx).hide();
   
   dmatidx += x; 
   if (dmatidx<1) {
      dmatidx=1;
   }
   else if (dmatidx>ntab) {
      dmatidx=ntab;
   }
   
   $('#dmat'+dmatidx).show();
   
   if (dmatidx==1) {
      $('#goback').hide();
   }
   else {
      $('#goback').show();
   } 
   
   if (dmatidx==ntab) {
      $('#gonext').hide();
   }
   else {
      $('#gonext').show();
   }
} 
function directState(x)
{                 
   $('#stateDlg').dialog('close');
   thermo[forThermo].State = x;
   drawStatus(forThermo+1); // param: 1,2,3...
   sendXMLtoMaster() ;
}
function newstate(i) // i=1,2,3...  
{
   if (!authenticated) {
      oLoginDlg.dialog('open');
      return;
   }
   
   forThermo = i-1; // 0,1,2...
   
   if (popupsts) {
      $('#subtitle').text( i+'# '+thermo[forThermo].Name );
      $('#stateDlg').dialog('open');
   }
   else {
      thermo[forThermo].State = thermo[forThermo].State+1;
      if (thermo[forThermo].State > 3) {
         thermo[forThermo].State = 0;
      }
      drawStatus(i);
      sendXMLtoMaster() ;
   }
}   
function drawStatus(i) // i=1,2,3,4 (thermometer a/a)  
{
   var ids='#tstate'+i;
   
   switch (j=thermo[i-1].State)
   {
   case 0:
      $(ids).text(states[j]).removeClass().addClass('infoborder nonoper');
      break;
   case 1:
      $(ids).text(states[j]).removeClass().addClass('infoborder operate');
      break;
   case 2:
      $(ids).text(states[j]).removeClass().addClass('infoborder anefodia');
      break;
   case 3:
      $(ids).text(states[j]).removeClass().addClass('infoborder apopsixi');
      break;
   case 4:
      $(ids).text(states[j]).removeClass().addClass('infoborder alarm');
      break;
   } 
   $(ids).text
}
function writeParamLines()
{
   var shtml='';
   
   for (var i=1;i<=tcount;i++) {
      shtml += '<tr>'+
            '<td>'+i+'</td>'+
            '<td><select id=pid'+i+'></select><br>'+
               '<input type=text class=Name id=pname'+i+'></td>'+
            '<td><input type=text class=numin id=plimitdn'+i+'><sup>o</sup><br>'+
               '<input type=text class=numin id=pwindn'+i+'><sup>o</sup></td>'+
            '<td><input type=text class=numin id=plimitup'+i+'><sup>o</sup><br>'+
               '<input type=text class=numin id=pwinup'+i+'><sup>o</sup></td>'+
            '<td><input type=checkbox id=soundalm'+i+'> <label for=soundalm'+i+'>Ηχος</label><br>'+
               '<input type=checkbox id=smsalm'+i+'> <label for=smsalm'+i+'>SMS</label><br>'+
               '<input type=checkbox id=relayalm'+i+'> <label for=relayalm'+i+'>Relay</label></td>'+
            '<td><input type=text class=numin id=winmint'+i+'> min<br>'+
               '<input type=text class=numin id=recsec'+i+'> sec</td>'+
            '<td><input type=text class=numin2 id=relayid'+i+' readonly></td>'+
         '</tr>';
   }
   
   $('#parambody').html(shtml);
}
function XMLWriter()
{
   this.XML=[ '<?xml version="1.0" ?>', '<ThermometerParams xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">' ];
   this.openRoot=true;
   this.Nodes=[];
   this.Open='';
}
XMLWriter.prototype.FormatXML = function(Str)
{
   if (Str)
      return Str.replace(/&/g, "&amp;").replace(/\"/g, "&quot;").replace(/\'/g, "&apos;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
   else 
      return "";
}
XMLWriter.prototype.BeginNode = function(Name)
{
   this.Nodes.push(Name);
   this.XML.push("<"+Name+">");
}
XMLWriter.prototype.EndNode = function()
{
   this.XML.push("</"+this.Nodes.pop()+">\n");
}
XMLWriter.prototype.Node = function(Name, Value)
{
   if (typeof Value==='boolean') {
      Value = Value?'true':'false'; 
   }
   else if (typeof Value!=='string') {
      Value = Value.toString();
   }
   this.XML.push( "<"+Name );
   this.XML.push( (Value=="" || !Value) ? "/>\n" : ">"+this.FormatXML(Value)+"</"+Name+">\n" );
}
XMLWriter.prototype.toString = function()
{
   if (this.openRoot) {
      this.XML.push( '</ThermometerParams>' );
      this.openRoot=false;
   }
   return this.XML.join('');
}

var aHighlight=true;

function showAlarm()
{                       
   if (aHighlight) {
      var al=false;
      
      for (var i=0;i<tcount;i++) {
         if (thermo[i].State==4) {
            al=true;
            break;
         }
      }
      
      if (al) {
         $('#ialarm').removeClass('alarm_off').addClass('alarm_on');
      }
      else {
         $('#ialarm').removeClass('alarm_on').addClass('alarm_off');
      }
   }
   else {
      $('#ialarm').removeClass('alarm_on').addClass('alarm_off');
   }
   
   aHighlight = !aHighlight; 
}
window.setInterval(showAlarm,500);